''*******************************
''* FONT.spin v1.0       5/2016 *
''* Author: Werner L. Schneider *
''*******************************
''
''
VAR

    long cog                     ' cog flag/id

    'DO NOT REARRANGE LONGS
    long font_ptr                ' 3 contiguous longs
    long buff_ptr
    long flag


PUB start(FontPtr, BuffPtr) : okay
    stop
    longmove(@font_ptr, @FontPtr, 2)
    okay := cog := cognew(@entry, @font_ptr) + 1


PUB stop
    if cog
        cogstop(cog~ - 1)
    longfill(@font_ptr, 0, 3)


PUB normal
    flag := 1
    repeat until flag == 0  
    

PUB big
    flag := 2
    repeat until flag == 0  


DAT

'***********************************
'* Assembly language "font" driver *
'***********************************

                        org     
'
' Entry
'
entry                   mov       t1, PAR
                        mov       _fontptr, t1            ' get font_ptr  

                        add       t1, #4                  
                        mov       _buffptr, t1            ' get buff_ptr  

                        add       t1, #4                  
                        mov       _flagptr, t1            ' get flag_ptr  
 
waitflag                rdlong    t1, _flagptr     wz
             if_z       jmp       #waitflag     
                        and       t1, #1           wz, nr
             if_nz      jmp       #set_normal
                        and       t1, #2           wz, nr
             if_nz      jmp       #set_big
                        jmp       #waitflag

'*********************************************************************************************************

set_normal              mov       t1, #128

chloop                  mov       ch, #128
                        sub       ch, t1

                        mov       tmp, ch
                        shr       tmp, #4                 ' tmp / 16
                        shl       tmp, #8                 ' tmp * 256
                        mov       src, ch
                        ror       src, #4
                        shr       src, #28                ' src = ch // 16
                        add       src, tmp

                        rdlong    _font, _fontptr
                        add       _font, src

                        mov       t2, #4
saloop                  mov       sa, #4
                        sub       sa, t2

                        mov       ta, ch
                        shl       ta, #2                  ' ta * 4
                        mov       tmp, sa
                        shl       tmp, #10                ' tmp * 1024
                        add       ta, tmp

                        rdlong    _buff, _buffptr
                        add       _buff, ta 

                        mov       t3, #4
sbloop                  rdbyte    _data, _font
                        rev       _data, #24
                        wrbyte    _data, _buff

                        add       _font, #16
                        add       _buff, #1

                        djnz      t3, #sbloop

                        djnz      t2, #saloop

                        djnz      t1, #chloop

                        mov       t1, #0
                        wrlong    t1, _flagptr
                        jmp       #waitflag

'*********************************************************************************************************
 
set_big                 mov       t1, #4

iloop                   mov       i, #4
                        sub       i, t1                   ' i = 0 - 3

                        rdlong    _buff, _buffptr
                        mov       src, i
                        shl       src, #10                ' src * 1024
                        add       _buff, src

                        mov       t2, v512                 
jloop                   rdbyte    sa, _buff
                        mov       sb, sa
                        shr       sa, #4
                        and       sa, #$F
                        and       sb, #$F

                        mov       _data, sb
                        call      #stretch

                        wrbyte    _data, _buff

                        add       _buff, v512

                        mov       _data, sa
                        call      #stretch
                        wrbyte    _data, _buff

                        sub       _buff, #511

                        djnz      t2, #jloop

                        djnz      t1, #iloop

                        mov       t1, #0
                        wrlong    t1, _flagptr
                        jmp       #waitflag

'*********************************************************************************************************

stretch                 mov       tmp, _data
                        mov       _data, #0
                        shl       tmp, #28

                        mov       t3, #4
stloop                  rol       tmp, #1
                        mov       ta, tmp
                        and       ta, #$01
                        cmp       ta, #$01        wz
         if_z           add       _data, #$03               
                        shl       _data, #2
                        djnz      t3, #stloop

                        shr       _data, #2
stretch_ret             ret

'*********************************************************************************************************

                        ' Data

v512                    long      512

'
' Uninitialized data
'
t1                      res       1
t2                      res       1
t3                      res       1

ch                      res       1
tmp                     res       1
src                     res       1
ta                      res       1
sa                      res       1
sb                      res       1

i                       res       1
j                       res       1

_fontptr                res       1
_buffptr                res       1
_flagptr                res       1

_font                   res       1
_buff                   res       1
_data                   res       1 


{{

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies
or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 

}}