''*******************************
''* I2CSPIN.spin v1.0    1/2019 *
''* Author: Werner L. Schneider *
''*******************************
''
''
VAR

    long scl 
    long sda                   
    long count
    long addr
    long buff


PUB start(pin_scl, pin_sda)

    scl := pin_scl
    sda := pin_sda

    dira[scl]~                          ' Set scl as input
    dira[sda]~                          ' Set sda as input


PUB read(par_count, par_addr, par_buff) | i, addrhi, addrlo

    count := par_count
    addr := par_addr
    buff := par_buff
    
    repeat
        i2c_start
        if i2c_write($A0) == 0
            quit

    addrhi := (addr >> 8) & $FF
    addrlo := addr & $FF 
    i2c_write(addrhi)         
    i2c_write(addrlo)         
    
    i2c_start

    i2c_write($A1)         

    repeat par_count
        byte[buff++] := i2c_read 
        count--

    i2c_stop
    waitcnt(400_000 + cnt)      


PUB write(par_count, par_addr, par_buff) | i, addrhi, addrlo

    count := par_count
    addr := par_addr
    buff := par_buff

    repeat
        i2c_start
        if i2c_write($A0) == 0
            quit

    addrhi := (addr >> 8) & $FF
    addrlo := addr & $FF 
    i2c_write(addrhi)         
    i2c_write(addrlo)         

    repeat i from 0 to count-1
        i2c_write(byte[buff++])
        
    i2c_stop
    waitcnt(400_000 + cnt)      


PRI i2c_start

    dira[sda]~~                         ' Set sda as output
    outa[sda]~~                         ' Set sda High
    dira[scl]~~                         ' Set scl as output
    outa[scl]~~                         ' Set scl High
    outa[sda]~                          ' Set sda Low
    outa[scl]~                          ' Set scl Low


PRI i2c_stop

    dira[sda]~~                         ' Set sda as output
    outa[sda]~                          ' Set sda Low
    outa[scl]~~                         ' Set scl High
    outa[sda]~~                         ' Set sda High
    dira[scl]~                          ' Set scl as input
    dira[sda]~                          ' Set sda as input


PRI i2c_read | d

    dira[sda]~                          ' Set sda as input
    d := 0
    repeat 8
        d <<= 1
        outa[scl]~~                     ' Set scl High
        d |= ina[sda]
        outa[scl]~                      ' Set scl Low
    if count == 1
        outa[sda]~~                     ' Set sda High  NACK
    else    
        outa[sda]~                      ' Set sda Low   ACK

    dira[sda]~~                         ' Set sda as output
    outa[scl]~~                         ' Set scl High
    outa[scl]~                          ' Set scl Low
    return d
    

PRI i2c_write(data) : ack | bitmask

    bitmask := $80
    repeat 8
        if data & bitmask == 0
            outa[sda]~                  ' Set sda Low   
        else
            outa[sda]~~                 ' Set sda High
        outa[scl]~~                     ' Set scl High
        outa[scl]~                      ' Set scl Low
        bitmask >>= 1
    dira[sda]~                          ' Set sda as input
    outa[scl]~~                         ' Set scl High
    ack := ina[sda]
    outa[scl]~                          ' Set scl Low
    outa[sda]~                          ' Set sda Low   
    dira[sda]~~                         ' Set sda as output

        